
angular.module('beamng.apps')
.directive('classicEscDark', ['StreamsManager', 'bngApi', function (StreamsManager, bngApi) {
  return {
    template: '<div style="cursor: pointer; overflow: hidden;"><canvas id="cEscDark"></canvas></div>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
        
        var streams = ['electrics', 'escInfo'];
        StreamsManager.add(streams);
        scope.$on('$destroy', function () {
            StreamsManager.remove(streams);
        });

        var canvas = element.find("canvas")[0];
            
        var values = [];

        var gearType = "";
        var gearNames = ["P","R","N","D","2","1"];
        var gearNumStr, gearDirStr;


        document.getElementById("cEscDark").addEventListener('click', function () {
            bngApi.activeObjectLua("if controller.getController('driveModes') then controller.getController('driveModes').nextDriveMode() else controller.getControllerSafe('esc').toggleESCMode() end");
        }, false);
        

        scope.$on('streamsUpdate', function (event, streams) {
            canvas.width = element[0].clientWidth;
            canvas.height = canvas.width / 1.4444;

            var escActive = streams.electrics.escActive;
            var tcsActive = streams.electrics.tcsActive;

            var w = canvas.width;
            var h = canvas.height;
            var scale = w / 100;

            //console.log(scale);

            var ctx = canvas.getContext('2d');

            ctx.scale(scale, scale);
            ctx.clearRect(0, 0, w, h);
            ctx.fillStyle = "rgba(0, 0, 0, 0.9)";
            ctx.fillRect(0, 0, w, h);

            if(streams.engineInfo) {
                if(streams.escInfo) {
                    ctx.textAlign="center";
                    ctx.font='18px Arial';
                    ctx.fillStyle = "rgb(220, 220, 220)";
                    if(escActive) {
                        ctx.fillStyle = "#FF8000";
                    }
                    ctx.fillText("ESC", 28, 22);

                    ctx.fillStyle = "rgb(220, 220, 220)";
                    if(tcsActive) {
                        ctx.fillStyle = "#FF8000";
                    }
                    ctx.fillText("TCS", 72, 22);

                    var clr = streams.escInfo.ledColor;
                    ctx.fillStyle = "#" + clr;
                    ctx.fillRect(0, 31, w, 4);
                } else {
                    ctx.textAlign="center";
                    ctx.font='18px Arial';
                    ctx.fillStyle = "rgb(220, 220, 220)";

                    ctx.fillText("No ESC", 50, 24);
                }

                //ctx.fillText("Gears (" + trans + ")", 50, 62);

            }

        });


        scope.$on('VehicleReset', function (_, data) {
        	scope.updateGearbox();
        });

        scope.$on('VehicleFocusChanged', function (_, data) {
        	scope.updateGearbox();
        });

        scope.updateGearbox = function() {
			try {
        		var exec = `powertrain.getDevice("gearbox")==null and "electric" or powertrain.getDevice("gearbox").type`;
	            bngApi.activeObjectLua(exec, function(data) {
					gearType = data;
	            });
	        } catch(e) {
	        	console.log("error");
	        }
        };
        
        scope.updateGearbox();

        function pad(num, size) {
            var s = num+"";
            while (s.length < size) s = "0" + s;
            return s;
        }
    }
  };
}]);
