
angular.module('beamng.apps')
.directive('classicTachoDark', ['StreamsManager', function (StreamsManager) {
  return {
    template: '<div style="overflow: hidden;"><canvas id="cTachoDark" height="90px"></canvas></div>',
    replace: true,
    restrict: 'EA',
    link: function (scope, element, attrs) {
        

        var streams = ['electrics', 'engineInfo'];
        StreamsManager.add(streams);
        scope.$on('$destroy', function () {
            StreamsManager.remove(streams);
        });

        var canvas = element.find("canvas")[0];
            
        var values = [];

        scope.$on('streamsUpdate', function (event, streams) {
            canvas.width = element[0].clientWidth;
            canvas.height = canvas.width * 3.3333;
            var rpm = Math.round(Number(streams.engineInfo[4]));
            var rpmMax = streams.engineInfo[1];
            var rpmIdle = streams.engineInfo[0];
            
            var w = canvas.width;
            var h = canvas.height;
            var scale = w / 200;

            //console.log(scale);

            var ctx = canvas.getContext('2d');

            ctx.scale(scale, scale);
            ctx.clearRect(0, 0, w, h);
            ctx.fillStyle = "rgba(0, 0, 0, 0.9)";
            ctx.fillRect(0, 0, w, h);
            var rgba='RGBA';
            if(rpm < rpmIdle*1.25) {        //we are at idle, blue
                rgba+='(80,80,255,0.5)';
            } else if(rpm > rpmMax*0.9) {   //we are near redline, red
                rgba+='(255,80,80,0.5)';
            } else {                        //normal rpm, green
                rgba+='(80,255,80,0.5)';
            }
            ctx.fillStyle = rgba;

            
            //Make the bar
            var fillAmount = Math.abs(rpm/(rpmMax/160));

            if(fillAmount > 160) fillAmount = 160;
            ctx.fillRect(20, 10, fillAmount, 25);

            //setup text
            ctx.font='20px Arial';
            ctx.textAlign="center";

            //Add RPM value to bar
            ctx.fillStyle = "white";
            ctx.fillText(pad(Math.abs(rpm), 4),100,30);

            ctx.font='10px Arial';
            ctx.fillText("Engine RPM",100,62);

            ctx.font='10px Arial';
            ctx.fillText("0000",20,48);
            ctx.fillText(rpmMax,180,48);


            //add border
            ctx.strokeStyle = "rgb(220, 220, 220)";
            ctx.lineWidth = 1;
            ctx.strokeRect(20,10,160,25);
        });
        function pad(num, size) {
            var s = num+"";
            while (s.length < size) s = "0" + s;
            return s;
        }
    }
  };
}]);
